'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assocPath = require('ramda/src/assocPath');

var _assocPath2 = _interopRequireDefault(_assocPath);

var _curry = require('ramda/src/curry');

var _curry2 = _interopRequireDefault(_curry);

var _keys = require('ramda/src/keys');

var _keys2 = _interopRequireDefault(_keys);

var _zipObj = require('ramda/src/zipObj');

var _zipObj2 = _interopRequireDefault(_zipObj);

var _mergeDeepRight = require('ramda/src/mergeDeepRight');

var _mergeDeepRight2 = _interopRequireDefault(_mergeDeepRight);

var _assoc = require('ramda/src/assoc');

var _assoc2 = _interopRequireDefault(_assoc);

var _prop = require('ramda/src/prop');

var _prop2 = _interopRequireDefault(_prop);

var _propOr = require('ramda/src/propOr');

var _propOr2 = _interopRequireDefault(_propOr);

var _always = require('ramda/src/always');

var _always2 = _interopRequireDefault(_always);

var _partial = require('ramda/src/partial');

var _partial2 = _interopRequireDefault(_partial);

var _is = require('ramda/src/is');

var _is2 = _interopRequireDefault(_is);

var _ifElse = require('ramda/src/ifElse');

var _ifElse2 = _interopRequireDefault(_ifElse);

var _map = require('ramda/src/map');

var _map2 = _interopRequireDefault(_map);

var _reduce = require('ramda/src/reduce');

var _reduce2 = _interopRequireDefault(_reduce);

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _validate = require('./validate');

var _validate2 = _interopRequireDefault(_validate);

var _isValid = require('./utils/isValid');

var _isValid2 = _interopRequireDefault(_isValid);

var _debounce = require('./helpers/debounce');

var _debounce2 = _interopRequireDefault(_debounce);

var _updateFormValues = require('./updaters/updateFormValues');

var _updateFormValues2 = _interopRequireDefault(_updateFormValues);

var _updateSyncErrors = require('./updaters/updateSyncErrors');

var _updateSyncErrors2 = _interopRequireDefault(_updateSyncErrors);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
/* eslint-disable no-nested-ternary, no-unneeded-ternary */


/**
 * Calculates the new state to be set depending on the actions triggered via the form.
 *
 * Can be an entry point for externally changing the state in future versions, by defining own update functions that
 * change the next state depending on certain user actions. For now this is only an internal implementation.
 *
 * @param {Array} updateFns all update functions that need to change to the current state
 * @param {Object} state the actual state
 * @param {String} type defines which action should be handled via the update functions
 * @param {Object} enhancedProps containing the props as well as additional information like field name or value if available
 * @returns {Object} return the new state that needs to be set.
 */
var runUpdates = function runUpdates(updateFns, state, type, enhancedProps) {
  return (0, _reduce2.default)(function (updatedState, updateFn) {
    return updateFn(updatedState, type, enhancedProps);
  }, state, updateFns

  /**
   * Maps an empty array to every item of the list and returns a map representing the items as keys
   * Also works with deep nested data.
   *
   * @param {Array} obj the to object to convert
   * @returns {Array}
   * @example
   *
   *    initializeErrors({'a': null 'b': null}) //=> {a: [], b: []}
   *
   *    initializeErrors: [{'a': null, b: {c: {d: null}}}] //=> {'a': [], b: {c: {d: []}}}
   *
   */
  );
};var initializeErrors = function initializeErrors(obj) {
  return (0, _map2.default)((0, _ifElse2.default)((0, _is2.default)(Object), (0, _partial2.default)(initializeErrors, []), (0, _always2.default)([])), obj

  /**
   * revalidation expects a React Component and returns a React Component containing additional functions and props
   * for managing local component state as well validating that state, wrapping the originally provided Component.
   */
  );
};function revalidation(Component // eslint-disable-line comma-dangle
) {
  var HigherOrderFormComponent = function (_React$Component) {
    _inherits(HigherOrderFormComponent, _React$Component);

    function HigherOrderFormComponent(props) {
      _classCallCheck(this, HigherOrderFormComponent);

      var _this = _possibleConstructorReturn(this, (HigherOrderFormComponent.__proto__ || Object.getPrototypeOf(HigherOrderFormComponent)).call(this, props));

      _initialiseProps.call(_this);

      var form = (0, _propOr2.default)([], 'initialState', props);
      var initErrors = initializeErrors(form);

      _this.state = {
        form: form,
        errors: initErrors,
        asyncErrors: initErrors,
        debounceFns: _this.createDebounceFunctions((0, _prop2.default)('initialState', props)),
        submitted: false
      };
      return _this;
    }

    _createClass(HigherOrderFormComponent, [{
      key: 'componentWillReceiveProps',
      value: function componentWillReceiveProps(nextProps) {
        var _this2 = this;

        var updateForm = nextProps.updateForm,
            _nextProps$asyncError = nextProps.asyncErrors,
            asyncErrors = _nextProps$asyncError === undefined ? {} : _nextProps$asyncError;

        var type = this.getValidateOnChange(this.props.validateOnChange) ? [_constants.UPDATE_ALL, _constants.VALIDATE_ALL] : [_constants.UPDATE_ALL];

        this.setState(function (state, props) {
          var nextState = updateForm ? runUpdates(_this2.updateFns, state, type, _extends({}, props, { value: updateForm })) : state;

          var updatedState = (0, _assoc2.default)('asyncErrors', (0, _mergeDeepRight2.default)((0, _prop2.default)('asyncErrors', state), asyncErrors), nextState);
          return updatedState;
        });
      }
    }, {
      key: 'createDebounceFunctions',
      value: function createDebounceFunctions(form) {
        var _this3 = this;

        return (0, _zipObj2.default)((0, _keys2.default)(form), (0, _map2.default)(function (name) {
          return (0, _debounce2.default)(name, _this3.updateField, _this3.runAsync);
        }, (0, _keys2.default)(form) // eslint-disable-line comma-dangle
        ));
      }
    }, {
      key: 'render',
      value: function render() {
        var _state = this.state,
            form = _state.form,
            errors = _state.errors,
            asyncErrors = _state.asyncErrors,
            debounceFns = _state.debounceFns,
            submitted = _state.submitted;
        /* eslint-disable no-unused-vars */

        var _props = this.props,
            rules = _props.rules,
            asyncRules = _props.asyncRules,
            initialState = _props.initialState,
            updateForm = _props.updateForm,
            validateSingle = _props.validateSingle,
            validateOnChange = _props.validateOnChange,
            rest = _objectWithoutProperties(_props, ['rules', 'asyncRules', 'initialState', 'updateForm', 'validateSingle', 'validateOnChange']);

        var validateOnChangeResult = this.getValidateOnChange(validateOnChange);
        var valid = (0, _isValid2.default)((0, _validate2.default)(rules, form)) && (0, _isValid2.default)(errors) && validateOnChangeResult && (0, _isValid2.default)(asyncErrors);

        var revalidationProp = {
          form: form,
          errors: errors,
          asyncErrors: asyncErrors,
          valid: valid,
          submitted: submitted,
          debounce: debounceFns,
          updateState: this.updateState,
          onChange: this.updateField,
          onSubmit: this.validateAll,
          settings: { validateOnChange: validateOnChangeResult, validateSingle: validateSingle },
          UPDATE_FIELD: _constants.UPDATE_FIELD,
          VALIDATE: validateSingle ? _constants.VALIDATE_FIELD : _constants.VALIDATE_ALL,
          // short cut functions
          updateValue: this.updateValue,
          validateValue: this.validateValue,
          updateValueAndValidate: this.updateValueAndValidate
        };

        return (0, _react.createElement)(Component, _extends({}, rest, {
          revalidation: revalidationProp
        }));
      }
    }]);

    return HigherOrderFormComponent;
  }(_react2.default.Component);

  HigherOrderFormComponent.defaultProps = {
    initialState: {},
    validateSingle: false,
    validateOnChange: false
  };

  var _initialiseProps = function _initialiseProps() {
    var _this4 = this;

    this.updateFns = [_updateFormValues2.default, _updateSyncErrors2.default];

    this.update = function (type) {
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var cb = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function () {};

      _this4.setState(function (state, props) {
        return runUpdates(_this4.updateFns, state, type, _extends({}, props, data));
      }, cb // eslint-disable-line comma-dangle
      );
    };

    this.validateAll = function (cb) {
      _this4.update([_constants.VALIDATE_ALL], {}, function () {
        if (!cb) return;
        var valid = (0, _isValid2.default)(_this4.state.errors) && (!_this4.getValidateOnChange(_this4.props.validateOnChange) || (0, _isValid2.default)(_this4.state.asyncErrors));
        cb(_extends({}, _this4.state, { valid: valid }));
      } // eslint-disable-line comma-dangle
      );
    };

    this.updateState = function (nextState) {
      var type = _this4.getValidateOnChange(_this4.props.validateOnChange) ? [_constants.UPDATE_ALL, _constants.VALIDATE_ALL] : [_constants.UPDATE_ALL];

      _this4.update(type, { value: nextState });
    };

    this.updateField = (0, _curry2.default)(function (name, value) {
      var type = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;

      var updateType = _this4.getValidateOnChange(_this4.props.validateOnChange) ? type ? type : _this4.props.validateSingle ? [_constants.UPDATE_FIELD, _constants.VALIDATE_FIELD] : [_constants.UPDATE_FIELD, _constants.VALIDATE_ALL] : [_constants.UPDATE_FIELD];

      var fieldName = typeof name === 'string' ? [name] : name;
      _this4.update(updateType, { name: fieldName, value: value });
    });
    this.onChange = (0, _curry2.default)(function (name, value) {
      _this4.updateField(name, value, [_constants.UPDATE_FIELD]);
    });

    this.runAsync = function (asyncFn, name, value) {
      // clear the current async errors for the field
      var fieldName = typeof name === 'string' ? [name] : name;
      _this4.setState(function (state) {
        return (0, _assocPath2.default)(['asyncErrors'].concat(_toConsumableArray(fieldName)), [], state);
      });
      asyncFn(value, _this4.state);
    };

    this.updateValue = function (event) {
      var _extractNameAndValue = _this4.extractNameAndValue(event),
          name = _extractNameAndValue.name,
          value = _extractNameAndValue.value;

      _this4.updateField(name, value, [_constants.UPDATE_FIELD]);
    };

    this.validateValue = function (event) {
      var _extractNameAndValue2 = _this4.extractNameAndValue(event),
          name = _extractNameAndValue2.name,
          value = _extractNameAndValue2.value;

      _this4.updateField(name, value, [_constants.VALIDATE_FIELD]);
    };

    this.updateValueAndValidate = function (event) {
      var _extractNameAndValue3 = _this4.extractNameAndValue(event),
          name = _extractNameAndValue3.name,
          value = _extractNameAndValue3.value;

      _this4.updateField(name, value, [_constants.UPDATE_FIELD, _constants.VALIDATE_FIELD]);
    };

    this.extractNameAndValue = function (event) {
      var target = event.target;
      var value = target.type === 'checkbox' ? target.checked : target.value;
      var name = target.name;
      return { name: name, value: value };
    };

    this.getValidateOnChange = function (validateOnChange) {
      return (0, _is2.default)(Function, validateOnChange) ? validateOnChange({ submitted: _this4.state.submitted }) : validateOnChange;
    };
  };

  HigherOrderFormComponent.displayName = 'Revalidation_(' + (Component.displayName || Component.name || 'Component') + ')';
  return (0, _hoistNonReactStatics2.default)(HigherOrderFormComponent, Component);
}

exports.default = revalidation;