'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _T = require('ramda/src/T');

var _T2 = _interopRequireDefault(_T);

var _merge = require('ramda/src/merge');

var _merge2 = _interopRequireDefault(_merge);

var _always = require('ramda/src/always');

var _always2 = _interopRequireDefault(_always);

var _assocPath = require('ramda/src/assocPath');

var _assocPath2 = _interopRequireDefault(_assocPath);

var _path = require('ramda/src/path');

var _path2 = _interopRequireDefault(_path);

var _contains = require('ramda/src/contains');

var _contains2 = _interopRequireDefault(_contains);

var _cond = require('ramda/src/cond');

var _cond2 = _interopRequireDefault(_cond);

var _prop = require('ramda/src/prop');

var _prop2 = _interopRequireDefault(_prop);

exports.default = updateSyncErrors;

var _validate = require('../validate');

var _validate2 = _interopRequireDefault(_validate);

var _constants = require('../constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }
/* eslint-disable no-nested-ternary */


/**
 *
 * @param {[Object, Array]} state a tuple containing
 * @param {Array} effects
 * @param {Array} type
 * @param {Object} enhancedProps
 * @returns {[Object, Array]}
 */
function updateSyncErrors(state, type, enhancedProps) {
  var _enhancedProps$name = enhancedProps.name,
      name = _enhancedProps$name === undefined ? [] : _enhancedProps$name,
      rules = enhancedProps.rules;

  var errors = (0, _validate2.default)(rules, (0, _prop2.default)('form', state)

  /* eslint-disable no-shadow */
  );var updateState = (0, _cond2.default)([[function (type) {
    return (0, _contains2.default)(_constants.VALIDATE_FIELD, type) && name;
  }, function () {
    // reset any asyncErrors as the field value has been updated
    var cleanedState = (0, _path2.default)(['asyncErrors', name], state) ? (0, _assocPath2.default)(['asyncErrors', name], [], state) : state;
    return (0, _assocPath2.default)(['errors'].concat(_toConsumableArray(name)), (0, _path2.default)([].concat(_toConsumableArray(name)), errors), cleanedState);
  }], [(0, _contains2.default)(_constants.VALIDATE_ALL), (0, _always2.default)((0, _merge2.default)(state, { errors: errors, submitted: true }))], [_T2.default, (0, _always2.default)(state)]]);

  return updateState(type);
}