'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _isEmpty = require('ramda/src/isEmpty');

var _isEmpty2 = _interopRequireDefault(_isEmpty);

var _filter = require('ramda/src/filter');

var _filter2 = _interopRequireDefault(_filter);

var _is = require('ramda/src/is');

var _is2 = _interopRequireDefault(_is);

exports.default = isValid;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable no-mixed-operators, indent */

var isObject = function isObject(a) {
  return (0, _is2.default)(Object, a) && !(0, _is2.default)(Array, a) && !(0, _is2.default)(Function, a);
};

/**
 * check if object keys contain any string, function, non empty array or object values.
 *
 * @param obj the object to validate
 * @returns {boolean}
 */

function isValid() {
  var obj = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var a = (0, _filter2.default)(function (i) {
    return i && isObject(i) ? !isValid(i) : typeof i === 'string' || typeof i === 'function' || (0, _is2.default)(Array, i) && !(0, _isEmpty2.default)(i);
  }, obj // eslint-disable-line comma-dangle
  );

  return (0, _isEmpty2.default)(a // eslint-disable-line comma-dangle
  );
}