'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _identity = require('ramda/src/identity');

var _identity2 = _interopRequireDefault(_identity);

var _spected = require('spected');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Defines the shape of the validation results. Always return an empty [] when value is valid.
 * In case of errors simply return the array containing the errors.
 *
 * @example
 *
 *   validate({id: [[id => id > 0, 'Please provide a valid id']], {id: 1}})
 *   //=> {id: []}
 *
 *   validate({id: [[id => id > 0, 'Please provide a valid id']], {id: 0}})
 *   //=> {id: ['Please provide a valid id']}
 *
 */
exports.default = (0, _spected.validate)(function () {
  return [];
}, _identity2.default);